Edit

Items - Get Upstream Relations (beta)

Gets upstream relations for an item.

Note

This API is part of a Beta release and is provided for evaluation and development purposes only. It may change based on feedback and is not recommended for production use. When calling this API, callers must specify true as the value for the query parameter beta.

Returns all items that are upstream of the specified item, including the relation edges and referenced workspaces.

Permissions

The caller must have read permissions for the item.

Required Delegated Scopes

Item.Read.All or Item.ReadWrite.All

Microsoft Entra supported identities

This API supports the Microsoft identities listed in this section.

Identity Support
User Yes
Service principal and Managed identities Yes

Interface

GET https://api.fabric.microsoft.com/v1/workspaces/{workspaceId}/items/{itemId}/relations/upstream?beta={beta}

URI Parameters

Name In Required Type Description
itemId
path True

string (uuid)

The item ID.

workspaceId
path True

string (uuid)

The workspace ID.

beta
query True

boolean

This required parameter must be set to true to access this API, which is currently in beta.

Responses

Name Type Description
200 OK

RelationsResponse

Request completed successfully.

429 Too Many Requests

ErrorResponse

The service rate limit was exceeded. The server returns a Retry-After header indicating, in seconds, how long the client must wait before sending additional requests.

Headers

Retry-After: integer

Other Status Codes

ErrorResponse

Common error codes:

  • ItemNotFound - The requested item was not found.

  • InsufficientPrivileges - The caller does not have sufficient permissions to access the item.

Examples

Get upstream relations example

Sample request

GET https://api.fabric.microsoft.com/v1/workspaces/cfafbeb1-8037-4d0c-896e-a46fb27ff229/items/3546052c-ae64-4526-b1a8-52af7761426f/relations/upstream?beta=True

Sample response

{
  "items": [
    {
      "id": "9b218778-e7a5-4d73-8187-f10824047715",
      "type": "Lakehouse",
      "displayName": "Enterprise Sales Lakehouse",
      "workspaceId": "9a1f7d8b-4f9c-4c1e-b8e7-3d6c2b0a5f41"
    }
  ],
  "relations": [
    {
      "itemId": "3546052c-ae64-4526-b1a8-52af7761426f",
      "dependentOnItemId": "9b218778-e7a5-4d73-8187-f10824047715",
      "relationType": "PushData"
    }
  ],
  "workspaces": [
    {
      "id": "9a1f7d8b-4f9c-4c1e-b8e7-3d6c2b0a5f41",
      "displayName": "Data Engineering Workspace"
    }
  ]
}

Definitions

Name Description
ErrorRelatedResource

The error related resource details object.

ErrorResponse

The error response.

ErrorResponseDetails

The error response details.

ItemType

The type of the item. Additional item types may be added over time.

RelationsEdge

A relation edge between two items.

RelationsRelatedItem

An item that is related to the specified item. This is a subset of the full item object, containing only the properties returned by the relations APIs.

RelationsResponse

A response containing related items, relation edges, and referenced workspaces.

RelationsWorkspace

A workspace referenced in the relations response.

RelationType

The type of relation between the two items. Additional relation types may be added over time.

ErrorRelatedResource

The error related resource details object.

Name Type Description
resourceId

string

The resource ID that's involved in the error.

resourceType

string

The type of the resource that's involved in the error.

ErrorResponse

The error response.

Name Type Description
errorCode

string

A specific identifier that provides information about an error condition, allowing for standardized communication between our service and its users.

isRetriable

boolean

When true, the request can be retried. Use the Retry-After response header to determine the delay, if available.

message

string

A human readable representation of the error.

moreDetails

ErrorResponseDetails[]

List of additional error details.

relatedResource

ErrorRelatedResource

The error related resource details.

requestId

string (uuid)

ID of the request associated with the error.

ErrorResponseDetails

The error response details.

Name Type Description
errorCode

string

A specific identifier that provides information about an error condition, allowing for standardized communication between our service and its users.

message

string

A human readable representation of the error.

relatedResource

ErrorRelatedResource

The error related resource details.

ItemType

The type of the item. Additional item types may be added over time.

Value Description
Dashboard

PowerBI dashboard.

Report

PowerBI report.

SemanticModel

PowerBI semantic model.

PaginatedReport

PowerBI paginated report.

Datamart

PowerBI datamart.

Lakehouse

A lakehouse.

Eventhouse

An eventhouse.

Environment

An environment.

KQLDatabase

A KQL database.

KQLQueryset

A KQL queryset.

KQLDashboard

A KQL dashboard.

DataPipeline

A data pipeline.

Notebook

A notebook.

SparkJobDefinition

A spark job definition.

MLExperiment

A machine learning experiment.

MLModel

A machine learning model.

Warehouse

A warehouse.

Eventstream

An eventstream.

SQLEndpoint

An SQL endpoint.

MirroredWarehouse

A mirrored warehouse.

MirroredDatabase

A mirrored database.

Reflex

A Reflex.

GraphQLApi

An API for GraphQL item.

MountedDataFactory

A MountedDataFactory.

SQLDatabase

A SQLDatabase.

CopyJob

A Copy job.

VariableLibrary

A VariableLibrary.

Dataflow

A Dataflow.

ApacheAirflowJob

An ApacheAirflowJob.

WarehouseSnapshot

A Warehouse snapshot.

DigitalTwinBuilder

A DigitalTwinBuilder.

DigitalTwinBuilderFlow

A Digital Twin Builder Flow.

MirroredAzureDatabricksCatalog

A mirrored azure databricks catalog.

Map

A Map.

AnomalyDetector

An Anomaly Detector.

UserDataFunction

A User Data Function.

GraphModel

A GraphModel.

GraphQuerySet

A Graph QuerySet.

SnowflakeDatabase

A Snowflake Database to store Iceberg tables created from Snowflake account.

OperationsAgent

A OperationsAgent.

CosmosDBDatabase

A Cosmos DB Database.

Ontology

An Ontology.

EventSchemaSet

An EventSchemaSet.

DataAgent

A DataAgent.

MirroredCatalog

A MirroredCatalog.

AppBackend

An AppBackend.

OrgApp

An Org App.

OrgAppAudience

An Org App Audience.

DataBuildToolJob

A DataBuildToolJob.

AzureDatabricksStorage

A OneLake-backed storage item for Azure Databricks.

RelationsEdge

A relation edge between two items.

Name Type Description
dependentOnItemId

string (uuid)

The identifier of the item that the source item depends on.

itemId

string (uuid)

The source item identifier.

relationType

RelationType

The type of relation between the two items. Additional relation types may be added over time.

RelationsRelatedItem

An item that is related to the specified item. This is a subset of the full item object, containing only the properties returned by the relations APIs.

Name Type Description
displayName

string

The item display name.

id

string (uuid)

The item ID.

type

ItemType

The item type.

workspaceId

string (uuid)

The ID of the workspace that contains the item. Use this ID to find the workspace in the workspaces list.

RelationsResponse

A response containing related items, relation edges, and referenced workspaces.

Name Type Description
items

RelationsRelatedItem[]

A list of related items.

relations

RelationsEdge[]

A list of relation edges between items.

workspaces

RelationsWorkspace[]

A list of workspaces referenced by the related items.

RelationsWorkspace

A workspace referenced in the relations response.

Name Type Description
displayName

string

The workspace display name.

id

string (uuid)

The workspace identifier.

RelationType

The type of relation between the two items. Additional relation types may be added over time.

Value Description
CascadeDelete

A CascadeDelete relationship indicates that the item is the Parent of the dependentOnItemId and deleting the item will cause the Dependent item to also be deleted.

WeakAssociation

A WeakAssociation relationship indicates that there is a soft dependency on the item identified by the dependentOnItemId. If the Dependent item is deleted, the relationship will be removed.

Datasource

A Datasource relationship indicates that there is a soft dependency on the item identified by a common Datasource. If the Dependent item is deleted, the relationship will be removed.

PushData

A PushData relationship indicates that a dependent item writes/pushes data to dependecy item(the item identified by the dependentOnItemId). If the Dependent item is deleted, the relationship will be removed.

Orchestration

An Orchestration relationship indicates that an item executes management or orchestration processes of the dependency item(the item identified by the dependentOnItemId). If the Dependent item is deleted, the relationship will be removed.

Shortcut

A Shortcut relationship indicates that an item has a shortcut or link to data or data area from item identified by the dependentOnItemId. If the Dependent item is deleted, the relationship will be removed.

HiddenInWorkspace

HiddenInWorkspace indicates that the item that owns this relationship will be hidden in the workspace.